package adaptivehac;

import java.io.Serializable;
import java.util.TreeMap;
import java.util.Vector;

public class AlphabetHAC implements Serializable
{
  private static final long serialVersionUID = 1;

  public TreeMap<String, Integer> map;
  public Vector<String> tokens;
  public Vector<Boolean> universal;
  int numEntries;
  boolean growthStopped;

  public AlphabetHAC (int capacity)
  {
    this.map = new TreeMap<String, Integer>();//capacity);
    tokens = new Vector<String>();
    universal = new Vector<Boolean>();
    tokens.add(null);
    universal.add(null);
    
    numEntries = 0;
    growthStopped = false;
  }

  public AlphabetHAC()
  {
    this(1024);
  }

	
  public Integer getI(String entry)
  {
    Integer ret = map.get(entry);

    if (ret == null && !growthStopped) {
	    ret = numEntries + 1;
	    map.put(entry, ret);
      tokens.add(entry);
      universal.add(false);
	    numEntries++;
    }
	
    return ret;
  }

  public Integer getU(String entry)
  {
    Integer ret = map.get(entry);

    if (ret == null && !growthStopped) {
      ret = numEntries + 1;
      map.put(entry, ret);
      tokens.add(entry);
      universal.add(true);
      numEntries++;
    }
  
    return ret;
  }


  public boolean containsKey(String entry)
  {
    return map.containsKey(entry);
  }

  public int size()
  {
    return numEntries;
  }

  public void stopGrowth()
  {
    growthStopped = true;
  }

  public void allowGrowth()
  {
    growthStopped = false;
  }

  public boolean growthStopped()
  {
    return growthStopped;
  }
	
}
