package adaptivehac;

public class ElementCluster extends Cluster
{
  static public Pair<ElementCluster> EMPTY_PAIR_;
  static {
    EMPTY_PAIR_ = Pair.create(new ElementCluster(EMPTY_CLUSTER_, -1), 
                              new ElementCluster(EMPTY_CLUSTER_, -1));
  }

  // Clustering index.
  public int element_;
  // Ignore cluster component
  public boolean ignore_cluster_;
  
  public ElementCluster()
  {
    super();
    element_ = -1;
    ignore_cluster_ = false;
  }
  
  public ElementCluster(Element[] elements, int element, Cluster c1, Cluster c2)
  {
    super(elements, c1, c2);
    element_ = element;
    ignore_cluster_ = false;
  }
  
  public ElementCluster(Cluster c, int element)
  {
    super(c);
    element_ = element;
    ignore_cluster_ = false;
  }
  
  public ElementCluster(Element el)
  {
    super(el);
    element_ = 0;
    ignore_cluster_ = false;
  }
  
  public Element getElement()
  {
    return elements_[element_];
  }
  
  public void setIgnoreCluster(boolean ignore)
  {
    ignore_cluster_ = ignore;
  }
  
  public boolean isIgnoreCluster()
  {
    return ignore_cluster_;
  }
  
  public boolean equals(Object o)
  {
    ElementCluster ec = (ElementCluster) o;
    
    return elements_ == ec.elements_ && element_ == ec.element_;
  }
  
}
