package adaptivehac;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.util.Map.Entry;

public class FeatureVector {
  
  public Vector<Feature> features_;
  
  public FeatureVector()
  {
    features_ = new Vector<Feature>();
  }
  
  public void add(int index, double value)
  {
    features_.add(new Feature(index, value));
  }
  
  public void add(FeatureVector fv)
  {
    features_.addAll(fv.features_);
  }
  
  public void addNew(FeatureVector fv)
  {
    HashMap<Integer, Double> sum = new HashMap<Integer, Double>();
    for (int i = 0; i < fv.features_.size(); i++) {
      Feature feature = fv.features_.get(i);
      Double val = sum.get(feature.index_);
      if (val == null)
        val = new Double(0);
      sum.put(feature.index_, val + feature.value_);
    }
    for (int i = 0; i < features_.size(); i++) {
      Feature feature = features_.get(i);
      Double val = sum.get(feature.index_);
      if (val == null)
        val = new Double(0);
      sum.put(feature.index_, val + feature.value_);
    }
    
    features_ = new Vector<Feature>();
    Iterator<Entry<Integer, Double>> it = sum.entrySet().iterator();
    while (it.hasNext()) {
      Entry<Integer, Double> ii = it.next();
      add(ii.getKey(), ii.getValue());
    }
  }
  

  public void multiply(double c)
  {
    for (Feature feat : features_)
      feat.value_ = feat.value_ * c;
  }

}
