package adaptivehac;

public class Pair<T> {
  private final T left;
  private final T right;

  public T getRight()
  {
    return right;
  }

  public T getLeft()
  {
    return left;
  }

  public Pair(final T left, final T right)
  {
    this.left = left;
    this.right = right;
  }
  
  public static<U> Pair<U> create(U left, U right)
  {
    return new Pair<U>(left, right);
  }

  public final boolean equals(Object o)
  {
    if (!(o instanceof Pair<?>))
      return false;

    final Pair<?> other = (Pair<?>) o;
    
    return 
      equal(getLeft(), other.getLeft()) && equal(getRight(), other.getRight());
  }
  
  public static final boolean equal(Object o1, Object o2)
  {
    if (o1 == null)
      return o2 == null;

    return o1.equals(o2);
  }

  public int hashCode()
  {
    int hLeft = getLeft() == null ? 0 : getLeft().hashCode();
    int hRight = getRight() == null ? 0 : getRight().hashCode();

    return hLeft + (57 * hRight);
  }
  
}
