package adaptivehac;

import java.io.Serializable;

abstract public class RankingModel implements Serializable
{
  private static final long serialVersionUID = 1L;
  public AlphabetHAC alphabet_;
  protected Discriminant disc_;

  public RankingModel()
  {
    alphabet_ = new AlphabetHAC();
  }
  
  public double evaluate(Document doc, Pair<? extends Cluster> pair)
  {
    FeatureVector fv = doc.getFeatureVector(pair, alphabet_);
    return disc_.evaluate(fv);
  }

  public Discriminant getDiscriminant()
  {
    return disc_;
  }
  
  abstract public void printFeatureWeights();

}
